返回介绍

solution / 2400-2499 / 2462.Total Cost to Hire K Workers / README

发布于 2024-06-17 01:03:05 字数 6784 浏览 0 评论 0 收藏 0

2462. 雇佣 K 位工人的总代价

English Version

题目描述

给你一个下标从 0 开始的整数数组 costs ,其中 costs[i] 是雇佣第 i 位工人的代价。

同时给你两个整数 k 和 candidates 。我们想根据以下规则恰好雇佣 k 位工人:

  • 总共进行 k 轮雇佣,且每一轮恰好雇佣一位工人。
  • 在每一轮雇佣中,从最前面 candidates 和最后面 candidates 人中选出代价最小的一位工人,如果有多位代价相同且最小的工人,选择下标更小的一位工人。
    • 比方说,costs = [3,2,7,7,1,2] 且 candidates = 2 ,第一轮雇佣中,我们选择第 4 位工人,因为他的代价最小 [_3,2_,7,7,_1,2_] 。
    • 第二轮雇佣,我们选择第 1 位工人,因为他们的代价与第 4 位工人一样都是最小代价,而且下标更小,[_3,2_,7,_7,2_] 。注意每一轮雇佣后,剩余工人的下标可能会发生变化。
  • 如果剩余员工数目不足 candidates 人,那么下一轮雇佣他们中代价最小的一人,如果有多位代价相同且最小的工人,选择下标更小的一位工人。
  • 一位工人只能被选择一次。

返回雇佣恰好_ _k 位工人的总代价。

 

示例 1:

输入:costs = [17,12,10,2,7,2,11,20,8], k = 3, candidates = 4
输出:11
解释:我们总共雇佣 3 位工人。总代价一开始为 0 。
- 第一轮雇佣,我们从 [_17,12,10,2_,7,_2,11,20,8_] 中选择。最小代价是 2 ,有两位工人,我们选择下标更小的一位工人,即第 3 位工人。总代价是 0 + 2 = 2 。
- 第二轮雇佣,我们从 [_17,12,10,7_,_2,11,20,8_] 中选择。最小代价是 2 ,下标为 4 ,总代价是 2 + 2 = 4 。
- 第三轮雇佣,我们从 [_17,12,10,7,11,20,8_] 中选择,最小代价是 7 ,下标为 3 ,总代价是 4 + 7 = 11 。注意下标为 3 的工人同时在最前面和最后面 4 位工人中。
总雇佣代价是 11 。

示例 2:

输入:costs = [1,2,4,1], k = 3, candidates = 3
输出:4
解释:我们总共雇佣 3 位工人。总代价一开始为 0 。
- 第一轮雇佣,我们从 [_1,2,4,1_] 中选择。最小代价为 1 ,有两位工人,我们选择下标更小的一位工人,即第 0 位工人,总代价是 0 + 1 = 1 。注意,下标为 1 和 2 的工人同时在最前面和最后面 3 位工人中。
- 第二轮雇佣,我们从 [_2,4,1_] 中选择。最小代价为 1 ,下标为 2 ,总代价是 1 + 1 = 2 。
- 第三轮雇佣,少于 3 位工人,我们从剩余工人 [_2,4_] 中选择。最小代价是 2 ,下标为 0 。总代价为 2 + 2 = 4 。
总雇佣代价是 4 。

 

提示:

  • 1 <= costs.length <= 105
  • 1 <= costs[i] <= 105
  • 1 <= k, candidates <= costs.length

解法

方法一:优先队列(小根堆)

我们用一个优先队列(小根堆)维护当前的候选工人,用变量 $i$ 和 $j$ 标记最前面工人的最大小标和最后面工人的最小下标。初始时 $i = candidates - 1$,而 $j = n - candidates$。

我们先将前面 $candidates$ 个工人的代价放入优先队列中,再将最后面 $candidates$ 个工人的代价放入优先队列中,放入之前需要判断根据 $i$ 或 $j$ 是否已经在优先队列中,如果已经在优先队列中,则不需要再放入。

循环 $k$ 次,每次从优先队列中取出最小代价的工人,累加代价。如果当前取出的工人下标 $x$ 在最前面工人的下标范围 $[0,..i]$ 中,则将 $i$ 向右移动一位,然后判断是否要将 $i$ 对应的工人代价放入优先队列中;如果取出的下标在最后面工人的下标范围 $[j,..n-1]$ 中,则将 $j$ 向左移动一位,然后判断是否要将 $j$ 对应的工人代价放入优先队列中。

遍历结束后,将累加的代价作为答案返回。

时间复杂度 $O(n\times \log n)$。其中 $n$ 为数组 $costs$ 的长度。

class Solution:
  def totalCost(self, costs: List[int], k: int, candidates: int) -> int:
    q = []
    n = len(costs)
    i, j = candidates - 1, n - candidates
    for h in range(candidates):
      q.append((costs[h], h))
    for h in range(n - candidates, n):
      if h > i:
        q.append((costs[h], h))
    heapify(q)
    ans = 0
    for _ in range(k):
      c, x = heappop(q)
      ans += c
      if x <= i:
        i += 1
        if i < j:
          heappush(q, (costs[i], i))
      if x >= j:
        j -= 1
        if i < j:
          heappush(q, (costs[j], j))
    return ans
class Solution {
  public long totalCost(int[] costs, int k, int candidates) {
    PriorityQueue<int[]> q = new PriorityQueue<>((a, b) -> {
      if (a[0] == b[0]) {
        return a[1] - b[1];
      }
      return a[0] - b[0];
    });
    int n = costs.length;
    int i = candidates - 1, j = n - candidates;
    for (int h = 0; h < candidates; ++h) {
      q.offer(new int[] {costs[h], h});
    }
    for (int h = n - candidates; h < n; ++h) {
      if (h > i) {
        q.offer(new int[] {costs[h], h});
      }
    }
    long ans = 0;
    while (k-- > 0) {
      var e = q.poll();
      int c = e[0], x = e[1];
      ans += c;
      if (x <= i) {
        if (++i < j) {
          q.offer(new int[] {costs[i], i});
        }
      }
      if (x >= j) {
        if (--j > i) {
          q.offer(new int[] {costs[j], j});
        }
      }
    }
    return ans;
  }
}
using pii = pair<int, int>;

class Solution {
public:
  long long totalCost(vector<int>& costs, int k, int candidates) {
    priority_queue<pii, vector<pii>, greater<pii>> q;
    int n = costs.size();
    int i = candidates - 1, j = n - candidates;
    for (int h = 0; h < candidates; ++h) q.push({costs[h], h});
    for (int h = n - candidates; h < n; ++h)
      if (h > i) q.push({costs[h], h});
    long long ans = 0;
    while (k--) {
      auto [c, x] = q.top();
      q.pop();
      ans += c;
      if (x <= i) {
        if (++i < j) {
          q.push({costs[i], i});
        }
      }
      if (x >= j) {
        if (--j > i) {
          q.push({costs[j], j});
        }
      }
    }
    return ans;
  }
};
func totalCost(costs []int, k int, candidates int) int64 {
  q := hp{}
  n := len(costs)
  i, j := candidates-1, n-candidates
  for h := 0; h < candidates; h++ {
    heap.Push(&q, pair{costs[h], h})
  }
  for h := n - candidates; h < n; h++ {
    if h > i {
      heap.Push(&q, pair{costs[h], h})
    }
  }
  ans := 0
  for k > 0 {
    p := heap.Pop(&q).(pair)
    c, x := p.c, p.x
    ans += c
    if x <= i {
      i++
      if i < j {
        heap.Push(&q, pair{costs[i], i})
      }
    }
    if x >= j {
      j--
      if i < j {
        heap.Push(&q, pair{costs[j], j})
      }
    }
    k--
  }
  return int64(ans)
}

type pair struct{ c, x int }
type hp []pair

func (h hp) Len() int       { return len(h) }
func (h hp) Less(i, j int) bool { return h[i].c < h[j].c || h[i].c == h[j].c && h[i].x < h[j].x }
func (h hp) Swap(i, j int)    { h[i], h[j] = h[j], h[i] }
func (h *hp) Push(v any)    { *h = append(*h, v.(pair)) }
func (h *hp) Pop() any      { a := *h; v := a[len(a)-1]; *h = a[:len(a)-1]; return v }

如果你对这篇内容有疑问,欢迎到本站社区发帖提问 参与讨论,获取更多帮助,或者扫码二维码加入 Web 技术交流群。

扫码二维码加入Web技术交流群

发布评论

需要 登录 才能够评论, 你可以免费 注册 一个本站的账号。
列表为空,暂无数据
    我们使用 Cookies 和其他技术来定制您的体验包括您的登录状态等。通过阅读我们的 隐私政策 了解更多相关信息。 单击 接受 或继续使用网站,即表示您同意使用 Cookies 和您的相关数据。
    原文